--- vsftpd-1.1.3/prelogin.c	2002-10-22 07:11:22.000000000 +0800
+++ x/prelogin.c	2004-05-31 15:15:04.964829633 +0800
@@ -141,6 +141,7 @@
     str_empty(&p_sess->user_str);
     return;
   }
+/*
   if (!str_isempty(&p_sess->userlist_str))
   {
     int located = str_contains_line(&p_sess->userlist_str, &p_sess->user_str);
@@ -152,6 +153,7 @@
       return;
     }
   }
+*/
   if (is_anon && tunable_no_anon_password)
   {
     /* Fake a password */
@@ -172,6 +174,17 @@
     vsf_cmdio_write(p_sess, FTP_NEEDUSER, "Login with USER first.");
     return;
   }
+  if (!str_isempty(&p_sess->userlist_str))
+  {
+    int located = str_contains_line(&p_sess->userlist_str, &p_sess->user_str);
+    if ((located && tunable_userlist_deny) ||
+        (!located && !tunable_userlist_deny))
+    {
+      vsf_cmdio_write(p_sess, FTP_LOGINERR, "Permission denied.");
+      str_empty(&p_sess->user_str);
+      return;
+    }
+  }
   /* These login calls never return if successful */
   if (tunable_one_process_model)
   {
